# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify CentOS Linux and Scientific Linux as rhel
%if "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "sl" || "%{__distinit}" == "sls"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

# Coro available for all build targets at the moment
%global coro_available 1

# rpm 4.9 onwards don't do a versioned provides properly here for some reason
%global rpm49 %(rpm --version | perl -p -e 's/^.* (\\d+)\\.(\\d+).*/sprintf("%d.%03d",$1,$2) ge 4.009 ? 1 : 0/e' 2>/dev/null || echo 0)

# rpm 4.12 onwards does do versioned provides properly
%global rpm412 %(rpm --version | perl -p -e 's/^.* (\\d+)\\.(\\d+).*/sprintf("%d.%03d",$1,$2) ge 4.012 ? 1 : 0/e' 2>/dev/null || echo 0)

# TODO: BR: perl(Cache::Memory) when available
# TODO: BR: perl(Data::Peek) when available
# TODO: BR: perl(DBI::ContextualFetch) when available
# TODO: BR: perl(Devel::Leak) when available
# TODO: BR: perl(MLDBM::Serializer::JSON) when available
# TODO: BR: perl(MLDBM::Serializer::YAML) when available
# TODO: BR: perl(Net::Daemon::Test) when available

Name:		perl-DBI
Version:	1.643
Release:	6.%{__distinit}%{__distvers}
Summary:	A database access API for perl
License:	GPL+ or Artistic
URL:		http://dbi.perl.org/
Source0:	https://cpan.metacpan.org/modules/by-module/DBI/DBI-%{version}.tar.gz
Patch0:		DBI-1.616-shellbang.patch
# Module Build
BuildRequires:	coreutils
BuildRequires:	findutils
BuildRequires:	gcc
BuildRequires:	make
BuildRequires:	perl-devel
BuildRequires:	perl-generators
BuildRequires:	perl-interpreter
BuildRequires:	perl(ExtUtils::MakeMaker) >= 5.16
BuildRequires:	perl(File::Find)
BuildRequires:	perl(Getopt::Long)
BuildRequires:	perl(lib)
# Module Runtime
BuildRequires:	perl(base)
BuildRequires:	perl(bytes)
BuildRequires:	perl(Carp)
BuildRequires:	perl(Config)
BuildRequires:	perl(constant)
%if %{coro_available}
BuildRequires:	perl(Coro)
BuildRequires:	perl(Coro::Handle)
BuildRequires:	perl(Coro::Select)
%endif
BuildRequires:	perl(Cwd)
BuildRequires:	perl(Data::Dumper)
BuildRequires:	perl(DynaLoader)
BuildRequires:	perl(Errno)
BuildRequires:	perl(Exporter)
BuildRequires:	perl(Fcntl)
BuildRequires:	perl(File::Basename)
BuildRequires:	perl(File::Spec)
BuildRequires:	perl(FileHandle)
BuildRequires:	perl(IO::Dir)
BuildRequires:	perl(IO::File)
BuildRequires:	perl(IO::Select)
BuildRequires:	perl(IPC::Open3)
BuildRequires:	perl(RPC::PlClient)
BuildRequires:	perl(RPC::PlServer)
BuildRequires:	perl(Scalar::Util)
BuildRequires:	perl(Storable)
BuildRequires:	perl(strict)
BuildRequires:	perl(Symbol)
BuildRequires:	perl(Tie::Hash)
BuildRequires:	perl(UNIVERSAL)
BuildRequires:	perl(utf8)
BuildRequires:	perl(vars)
BuildRequires:	perl(warnings)
# Optional Runtime
BuildRequires:	perl(Clone)
# SQL::Statement → DBI
%if 0%{!?perl_bootstrap:1}
BuildRequires:	perl(SQL::Statement)
%endif
BuildRequires:	perl(Time::HiRes)
# Test Suite
BuildRequires:	perl(B)
BuildRequires:	perl(Benchmark)
BuildRequires:	perl(blib)
BuildRequires:	perl(File::Copy)
BuildRequires:	perl(File::Path)
BuildRequires:	perl(overload)
BuildRequires:	perl(Test::More) >= 0.88
BuildRequires:	perl(Thread)
BuildRequires:	perl(threads)
# Optional Tests
BuildRequires:	perl(Encode)
BuildRequires:	perl(JSON::XS)
BuildRequires:	perl(List::MoreUtils)
BuildRequires:	perl(Math::BigInt)
BuildRequires:	perl(MLDBM)
BuildRequires:	perl(Params::Util)
BuildRequires:	perl(Storable) >= 2.16
BuildRequires:	perl(Test::Pod) >= 1.41
BuildRequires:	perl(Test::Pod::Coverage) >= 1.04
# Runtime
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))
Requires:	perl(Clone)
Requires:	perl(FileHandle)
Requires:	perl(Time::HiRes)

# Make sure we get the right provide
%if ! %{rpm412}
Provides:	perl(DBI) = %{version}
%endif

# Avoid unwanted provides and dependencies (rpm 4.9 onwards)
%global __requires_exclude ^perl\\((RPC::.*|DBI::Util::_accessor)\\)
%global __provides_exclude ^(perl\\(DBI\\)$|DBI\\.so)

%description 
DBI is a database access Application Programming Interface (API) for
the Perl Language. The DBI API Specification defines a set of
functions, variables and conventions that provide a consistent
database interface independent of the actual database being used.

%if %{coro_available}
%package Coro
Summary:	Asynchronous DBD::Gofer stream transport using Coro
License:	GPL+ or Artistic
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))

%description Coro
This is an experimental asynchronous DBD::Gofer stream transport for DBI
implemented on top of Coro. The BIG WIN from using Coro is that it enables
the use of existing DBI frameworks like DBIx::Class.
%endif

%prep
%setup -q -n DBI-%{version} 

# Fix shellbangs
%patch0 -p1

# Fix permissions
chmod -c 755 dbixs_rev.pl

# Avoid unwanted dependencies (prior to rpm 4.9)
%if ! %{rpm49}
%global reqfilt /bin/sh -c "%{__perl_requires} | grep -Ev '^perl\\((RPC::.*|DBI::Util::_accessor)\\)'"
%global __perl_requires %{reqfilt}
# Filter unversioned provide (prior to rpm 4.9)
%global provfilt /bin/sh -c "%{__perl_provides} | grep -Ev '^perl\\(DBI\\)$'"
%global __perl_provides %{provfilt}
%endif

%build
perl Makefile.PL INSTALLDIRS=vendor OPTIMIZE="%{optflags}"
make %{?_smp_mflags}

%install
make pure_install DESTDIR=%{buildroot}
find %{buildroot} -type f -name .packlist -delete
find %{buildroot} -type f -name '*.bs' -empty -delete
%{_fixperms} -c %{buildroot}

# Remove Win32-specific files and manpages to avoid unwanted dependencies
rm -rf %{buildroot}%{perl_vendorarch}/{Win32,DBI/W32ODBC.pm}
rm -f %{buildroot}%{_mandir}/man3/{DBI::W32,Win32::DBI}ODBC.3pm

%check
make test

%files
%doc Changes README.md ex/perl_dbi_nulls_test.pl ex/profile.pl
%{_bindir}/dbilogstrip
%{_bindir}/dbiprof
%{_bindir}/dbiproxy
%{perl_vendorarch}/DBI.pm
%{perl_vendorarch}/dbixs_rev.pl
%{perl_vendorarch}/Bundle/
%{perl_vendorarch}/DBD/
%{perl_vendorarch}/DBI/
%{perl_vendorarch}/auto/DBI/
%{_mandir}/man1/dbilogstrip.1*
%{_mandir}/man1/dbiprof.1*
%{_mandir}/man1/dbiproxy.1*
%{_mandir}/man3/Bundle::DBI.3*
%{_mandir}/man3/DBD::*.3*
%{_mandir}/man3/DBI.3*
%{_mandir}/man3/DBI::*3*
%exclude %{perl_vendorarch}/DBD/Gofer/Transport/corostream.pm
%exclude %{_mandir}/man3/DBD::Gofer::Transport::corostream.3*

%if %{coro_available}
%files Coro
%doc ex/corogofer.pl
%{perl_vendorarch}/DBD/Gofer/Transport/corostream.pm
%{_mandir}/man3/DBD::Gofer::Transport::corostream.3*
%endif

%changelog
* Sun Aug  2 2020 Paul Howarth <paul@city-fan.org> - 1.643-6
- Rebuilt for https://fedoraproject.org/wiki/Fedora_33_Mass_Rebuild

* Mon Jun 29 2020 Paul Howarth <paul@city-fan.org> - 1.643-5
- Perl 5.32 rebuild

* Thu Mar 12 2020 Paul Howarth <paul@city-fan.org> - 1.643-3
- Add dependency on FileHandle - DBI sub connect_test_perf has:
  require "FileHandle.pm";

* Wed Feb 12 2020 Paul Howarth <paul@city-fan.org> - 1.643-2
- Rebuild

* Sat Feb  1 2020 Paul Howarth <paul@city-fan.org> - 1.643-1
- Update to 1.643
  - Fix memory corruption in XS functions when Perl stack is reallocated
  - Fix calling dbd_db_do6 API function
  - Fix potentially calling newSV(0) in malloc_using_sv()
  - Fix order of XS preparse() ps_accept and ps_return argument names
  - Fix a potential NULL profile dereference in dbi_profile()
  - Fix a buffer overflow on an overlong DBD class name
  - Remove remnants of support for perl ≤ v5.8.0
  - Update Devel::PPPort and remove redundant compatibility macros
  - Correct minor typo in documentation
  - Correct documentation introducing $dbh->selectall_array()
  - Introduce select and do wrappers earlier in the documentation
  - Mark as deprecated old API functions that overflow or are affected by
    Unicode issues
  - Add new attribute RaiseWarn, similar to RaiseError

* Fri Jul 26 2019 Paul Howarth <paul@city-fan.org> - 1.642-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_31_Mass_Rebuild

* Fri Jun  7 2019 Paul Howarth <paul@city-fan.org> - 1.642-4
- Perl 5.30 rebuild

* Fri Mar  8 2019 Paul Howarth <paul@city-fan.org> - 1.642-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_30_Mass_Rebuild

* Mon Oct 29 2018 Paul Howarth <paul@city-fan.org> - 1.642-1
- Update to 1.642
  - Fix '.' in @INC for proxy test under parallel load
  - Fix driver-related croak() in DBI->connect to report the original DSN
    (GH#67)
  - Introduce a new statement DBI method $sth->last_insert_id() (GH#64)
  - Allow to call $dbh->last_insert_id() method without arguments (GH#64)
  - Added a new XS API function variant dbd_db_do6() (GH#61)
  - Fix misprints in doc of selectall_hashref (GH#69)
  - Remove outdated links to DBI related training resources (CPAN RT#125999)

* Thu Jun 28 2018 Paul Howarth <paul@city-fan.org> - 1.641-2
- Perl 5.28 rebuild

* Tue Mar 20 2018 Paul Howarth <paul@city-fan.org> - 1.641-1
- Update to 1.641
  - Remove dependency on Storable 2.16 introduced in DBI 1.639 (GH#60)
  - Avoid compiler warnings in Driver.xst (GH#59)

* Mon Jan 29 2018 Paul Howarth <paul@city-fan.org> - 1.640-1
- Update to 1.640
  - Fix test t/91_store_warning.t for perl 5.10.0 (GH#57)
  - Add Perl 5.10.0 and 5.8.1 specific versions to Travis testing (GH#57)
  - Add registration of mariadb_ prefix for new DBD::MariaDB driver (GH#56)

* Tue Jan  2 2018 Paul Howarth <paul@city-fan.org> - 1.639-1
- Update to 1.639
  - Fix UTF-8 support for warn/croak calls within DBI internals (GH#53)
  - Fix dependency on Storable for perl older than 5.8.9
  - Add DBD::Mem driver, a pure-perl in-memory driver using DBI::DBD::SqlEngine
    (GH#42)
  - Corrected missing semicolon in example in documentation (GH#55)

* Thu Aug 17 2017 Paul Howarth <paul@city-fan.org> - 1.637-1
- Update to 1.637
  - Fix use of externally controlled format string (CWE-134) (GH#44); this
    could cause a crash if, for example, a db error contained a %%
    (https://cwe.mitre.org/data/definitions/134.html)
  - Fix extension detection for DBD::File related drivers
  - Fix tests for perl without dot in @INC (CPAN RT#120443)
  - Fix loss of error message on parent handle (GH#34)
  - Fix disappearing $_ inside callbacks (GH#47)
  - Allow objects to be used as passwords without throwing an error (GH#40)
  - Allow $sth NAME_* attributes to be set from Perl code (GH#45)
  - Added support for DBD::XMLSimple (GH#38)
  - Documentation updates:
    - Improve examples using eval to be more correct (GH#39)
    - Add cautionary note to prepare_cached docs re refs in %%attr (GH#46)
    - Small POD changes (Getting Help -> Online) (GH#33)
    - Adds links to more module names and fix typo (GH#43)
    - Typo fix (GH#37)
- Simplify provides filtering
- BR: perl-generators unconditionally
- BR: perl-interpreter rather than perl

* Thu Jun 15 2017 Paul Howarth <paul@city-fan.org> - 1.636-6
- Drop support for EOL distributions prior to F-13
  - Drop BuildRoot: and Group: tags
  - Drop explicit buildroot cleaning in %%install section
  - Drop explicit %%clean section
  - BR: perl-devel unconditionally
  - Drop workaround for building with Test::More < 0.88
  - Always run all tests since we now have perl > 5.8.x everywhere

* Mon Aug  1 2016 Paul Howarth <paul@city-fan.org> - 1.636-4
- Fix FTBFS when perl is not in the minimal buildroot

* Tue May 24 2016 Paul Howarth <paul@city-fan.org> - 1.636-3
- Coro available for Perl 5.24 now

* Tue May 17 2016 Paul Howarth <paul@city-fan.org> - 1.636-2
- Don't build Coro sub-package for Perl 5.24 onwards as Coro won't build
  there
- BR: perl-generators where possible

* Mon Apr 25 2016 Paul Howarth <paul@city-fan.org> - 1.636-1
- Update to 1.636
  - Fixed RaiseError/PrintError for UTF-8 errors/warnings (CPAN RT#102404)
  - Fixed cases where ShowErrorStatement might show incorrect Statement
    (CPAN RT#97434)
  - Fixed DBD::Gofer for UTF-8-enabled STDIN/STDOUT (PR#32)
  - Fixed fetchall_arrayref({}) behavior with no columns (PR#31)
  - Fixed tied CachedKids ref leak in attribute cache by weakening
    (CPAN RT#113852)
  - Fixed "panic: attempt to copy freed scalar" upon commit() or rollback()
    (CPAN RT#102791)
  - Treat undef in DBI::Profile Path as string "undef" (CPAN RT#113298)
  - Fix SQL::Nano parser to ignore trailing semicolon
  - Added @ary = $dbh->selectall_array(...) method (CPAN RT#106411)
  - Added appveyor support (Travis like CI for windows) (PR#30)
  - Corrected spelling errors in pod (CPAN RT#107838)
  - Corrected and/or removed broken links to SQL standards (CPAN RT#111437)
  - Corrected doc example to use dbi: instead of DBI: in DSN (CPAN RT#101181)
  - Removed/updated broken links in docs (PR#29)
  - Clarified docs for DBI::hash($string)
  - Removed the ancient DBI::FAQ module (CPAN RT#102714)
  - Fixed t/pod.t to require Test::Pod ≥ 1.41 (CPAN RT#101769)
  - Fix compilation for threaded perl ≤ 5.12 broken in 1.635 (CPAN RT#113955)
  - Change t/16destroy.t to avoid race hazard (CPAN RT#113951)
  - Output perl version and archname in t/01basics.t
  - Add perl 5.22 and 5.22-extras to travis-ci config
- Simplify find commands using -empty and -delete
- Prefer %%global over %%define
- Update patches as needed

* Mon Aug  3 2015 Paul Howarth <paul@city-fan.org> - 1.634-1
- Update to 1.634
  - Enabled strictures on all modules (GH#22); note that this might cause new
    exceptions in existing code - please take time for extra testing before
    deploying to production
  - Improved handling of row counts for compiled drivers and enable them to
    return larger row counts (IV type) by defining new *_iv macros
  - Fixed quote_identifier that was adding a trailing separator when there was
    only a catalog
  - Removed redundant keys() call in fetchall_arrayref with hash slice (GH#24)
  - Corrected pod xref to Placeholders section
  - Corrected pod grammar (GH#25)
  - Added support for tables('', '', '', '%%') special case
  - Added support for DBD prefixes with numbers (GH#19)
  - Added extra initializer for DBI::DBD::SqlEngine based DBD's
  - Added Memory Leaks section to the DBI docs
  - Added Artistic v1 & GPL v1 LICENSE file (GH#21)
- Update patches as needed

* Sun Jan 11 2015 Paul Howarth <paul@city-fan.org> - 1.633-1
- Update to 1.633
  - Fixed selectrow_*ref to return undef on error in list context instead of
    an empty list
  - Changed t/42prof_data.t more informative
  - Changed $sth->{TYPE} to be NUMERIC in DBD::File drivers as per the DBI
    docs; note TYPE_NAME is now also available
  - Fixed compilation error on bleadperl due DEFSV no longer being an lvalue
  - Added docs for escaping placeholders using a backslash
  - Added docs for get_info(9000) indicating ability to escape placeholders
  - Added multi_ prefix for DBD::Multi and ad2_ prefix for DBD::AnyData2
- Only do explicit provide for perl(DBI) with rpm 4.9 onwards
- Update patch for building with old Test::More versions

* Thu Nov  6 2014 Paul Howarth <paul@city-fan.org> - 1.632-1
- update to 1.632
  - fixed risk of memory corruption with many arguments to methods originally
    reported by OSCHWALD for Callbacks but may apply to other functionality in
    DBI method dispatch (CPAN RT#86744)
  - fixed DBD::PurePerl to not set $sth->{Active} true by default; drivers are
    expected to set it true as needed
  - fixed DBI::DBD::SqlEngine to complain loudly when prerequisite
    driver_prefix is not fulfilled (CPAN RT#93204)
  - fixed redundant sprintf argument warning (CPAN RT#97062)
  - fixed security issue where DBD::File drivers would open files from folders
    other than specifically passed using the f_dir attribute (CPAN RT#99508)
  - changed delete $h->{$key} to work for keys with 'private_' prefix per
    request in CPAN RT#83156; local $h->{$key} works as before
  - added security notice to DBD::Proxy and DBI::ProxyServer because they use
    Storable, which is insecure (CPAN RT#90475)
  - added note to AutoInactiveDestroy docs strongly recommending that it is
    enabled in all new code
- drop upstreamed security notice patch
- update patch for building with old Test::More versions
- classify buildreqs by usage

* Sun Sep 14 2014 Paul Howarth <paul@city-fan.org> - 1.631-7
- add a security warning about use of RPC::PlClient (#1030578, CPAN RT#90475)
- unconditionally build with Coro
- drop %%defattr, redundant since rpm 4.4

* Wed Jan 22 2014 Paul Howarth <paul@city-fan.org> - 1.631-2
- split DBD::Gofer::Transport::corostream into sub-package

* Mon Jan 20 2014 Paul Howarth <paul@city-fan.org> - 1.631-1
- update to 1.631
  - NOTE: this release changes the handle passed to Callbacks from being an
    'inner' handle to being an 'outer' handle; if you have code that makes use
    of Callbacks, ensure that you understand what this change means and review
    your callback code
  - fixed err_hash handling of integer err (CPAN RT#92172)
  - fixed use of \Q vs \E in t/70callbacks.t
  - changed the handle passed to Callbacks from being an 'inner' handle to
    being an 'outer' handle
  - improved reliability of concurrent testing
  - changed optional dependencies to "suggest"
  - changed to avoid mg_get in neatsvpv during global destruction
- update patch for building with old Test::More versions

* Fri Dec 20 2013 Paul Howarth <paul@city-fan.org> - 1.630-2
- make sure we get the best set of provides
- skip 35thrclone.t on perl 5.8, prone to hanging (CPAN RT#77523)

* Mon Oct 28 2013 Paul Howarth <paul@city-fan.org> - 1.630-1
- update to 1.630
  - NOTE: this release enables PrintWarn by default regardless of $^W;
    your applications may generate more log messages than before
  - fixed err for new drh to be undef, not to 0
  - moved DBIstcf* constants to util export tag (CPAN RT#83132)
  - PrintWarn is now triggered by warnings recorded in methods like STORE that
    don't clear err (CPAN RT#89015)
  - changed tracing to no longer show quote and quote_identifier calls at
    trace level 1
  - changed DBD::Gofer ping while disconnected set_err from warn to info
  - clarified wording of log message when err is cleared
  - changed bootstrap to use $XS_VERSION (CPAN RT#89618)
  - added connect_cached.connected Callback
  - clarified effect of refs in connect_cached attributes
  - extended ReadOnly attribute docs for when the driver cannot ensure read
    only
  - corrected SQL_BIGINT docs to say ODBC value is used
- update patch for building with old Test::More versions

* Mon Jul 22 2013 Paul Howarth <paul@city-fan.org> - 1.628-1
- update to 1.628 (see Changes for details)
- update patch for building with old Test::More versions

* Fri May 17 2013 Paul Howarth <paul@city-fan.org> - 1.627-1
- update to 1.627
  - fixed VERSION regression in DBI::SQL::Nano

* Wed May 15 2013 Paul Howarth <paul@city-fan.org> - 1.626-1
- update to 1.626
  - fixed pod text/link was reversed in a few cases (CPAN RT#85168)
  - handle aliasing of STORE'd attributes in DBI::DBD::SqlEngine
  - updated repository URI to git
  - fixed skip() count arg in t/48dbi_dbd_sqlengine.t
- update patch for building with old Test::More versions

* Fri Mar 22 2013 Paul Howarth <paul@city-fan.org> - 1.625-1
- update to 1.625
  - fixed heap-use-after-free during global destruction (CPAN RT#75614)
  - fixed ignoring RootClass attribute during connect() by
    DBI::DBD::SqlEngine (CPAN RT#84260)

* Fri Mar 22 2013 Paul Howarth <paul@city-fan.org> - 1.624-1
- update to 1.624
  - fixed Gofer for hash randomization in perl 5.17.10+ (CPAN RT#84146)
  - clarify docs for can() (CPAN RT#83207)

* Wed Jan  2 2013 Paul Howarth <paul@city-fan.org> - 1.623-1
- update to 1.623 (see Changes for details)
- update patch for building with old Test::More versions

* Mon Jul 16 2012 Paul Howarth <paul@city-fan.org> - 1.622-4
- Perl 5.16 post-bootstrap rebuild

* Wed Jul 11 2012 Paul Howarth <paul@city-fan.org> - 1.622-3
- BR: perl(base), perl(Carp), perl(Clone), perl(constant), perl(Cwd),
  perl(Data::Dumper), perl(Exporter), perl(File::Path), perl(File::Spec),
  perl(Getopt::Long), perl(IO::File), perl(IO::Select), perl(JSON::XS),
  perl(List::MoreUtils), perl(Math::BigInt), perl(lib), perl(RPC::PlServer),
  perl(Scalar::Util), perl(Storable), perl(Test::More) and perl(threads)
- Add version requirements for perl(Test::Pod) and perl(Test::Pod::Coverage)

* Wed Jun  6 2012 Paul Howarth <paul@city-fan.org> - 1.622-1
- update to 1.622
  - fixed lack of =encoding in non-ASCII pod docs (CPAN RT#77588)
  - corrected typo in DBI::ProfileDumper
- rediff UTF8 patch

* Wed May 23 2012 Paul Howarth <paul@city-fan.org> - 1.621-1
- update to 1.621
  - fixed segmentation fault when a thread is created from within another
    thread (CPAN RT#77137)

* Wed Apr 25 2012 Paul Howarth <paul@city-fan.org> - 1.620-1
- update to 1.620
  - modified column renaming in fetchall_arrayref, added in 1.619, to work on
    column index numbers, not names (an incompatible change)
  - reworked the fetchall_arrayref documentation
  - hash slices in fetchall_arrayref now detect invalid column names

* Tue Apr 24 2012 Paul Howarth <paul@city-fan.org> - 1.619-1
- update to 1.619
  - fixed the connected method to stop showing the password in trace file
  - fixed _install_method to set CvFILE correctly (CPAN RT#76296)
  - fixed SqlEngine "list_tables" (CPAN RT#67223, CPAN RT#69260)
  - optimized DBI method dispatch
  - optimized driver access to DBI internal state
  - optimized driver access to handle data
  - optimized fetchall_arrayref with hash slice (CPAN RT#76520)
  - allow renaming columns in fetchall_arrayref hash slices (CPAN RT#76572)
  - reserved snmp_ and tree_ for DBD::SNMP and DBD::TreeData
- don't need to remove empty directories from buildroot
- drop support for old distributions prior to FC-3:
  - drop old_perl patch, no longer needed
  - don't need to define %%{perl_vendorarch}
  - use %%{_fixperms} macro rather than our own chmod incantation
  - use DESTDIR rather than PERL_INSTALL_ROOT
- update patch for building with old Test::More versions

* Sun Feb 26 2012 Paul Howarth <paul@city-fan.org> - 1.618-1
- update to 1.618
  - fixed compiler warnings in Driver_xst.h
  - fixed compiler warning in DBI.xs
  - fixed Gofer tests failing on Windows (CPAN RT#74975)
  - fixed my_ctx compile errors on Windows
  - significantly optimized method dispatch via cache
  - significantly optimized DBI internals for threads
  - xsub to xsub calling optimization now enabled for threaded perls
  - corrected typo in example in docs
  - added note that calling clone() without an arg may warn in future
  - minor changes to the install_method() docs in DBI::DBD
  - updated dbipport.h from Devel::PPPort 3.20

* Fri Feb 10 2012 Paul Howarth <paul@city-fan.org> - 1.617-2
- don't BR: perl(SQL::Statement) if we're bootstrapping

* Mon Jan 30 2012 Paul Howarth <paul@city-fan.org> - 1.617-1
- update to 1.617
  - NOTE: The officially supported minimum perl version will change from
    perl 5.8.1 (2003) to perl 5.8.3 (2004) in a future release
  - fixed ParamTypes example in the pod
  - fixed the definition of ArrayTupleStatus and remove confusion over rows
    affected in list context of execute_array
  - fixed sql_type_cast example and typo in errors
  - fixed Gofer error handling for keeperr methods like ping
  - fixed $dbh->clone({}) (CPAN RT#73250)
  - fixed is_nested_call logic error (CPAN RT#73118)
  - enhanced performance for threaded perls
  - enhanced and standardized driver trace level mechanism
  - removed old code that was an ineffective attempt to detect people doing
    DBI->{Attrib}
  - clear ParamValues on bind_param param count error (CPAN RT#66127)
  - changed DBI::ProxyServer to require DBI at compile-time (CPAN RT#62672)
  - added pod for default_user to DBI::DBD
  - added CON, ENC and DBD trace flags and extended 09trace.t
  - added TXN trace flags and applied CON and TXN to relevant methods
  - added some more fetchall_arrayref(..., $maxrows) tests
  - clarified docs for fetchall_arrayref called on an inactive handle
  - clarified docs for clone method
  - added note to DBI::Profile about async queries
  - reserved spatialite_ as a driver prefix for DBD::Spatialite
  - reserved mo_ as a driver prefix for DBD::MO
  - updated link to the SQL Reunion 95 docs (CPAN RT#69577)
  - changed links for DBI recipes (CPAN RT#73286)
- BR: perl(RPC::PlClient) for extra test cover and to ensure that we can grok all of
  the module versions

* Thu Jun 23 2011 Paul Howarth <paul@city-fan.org> - 1.616-4
- rebuild for perl 5.14.1 in Rawhide
- make requires/provides filters work properly across all distributions
- nobody else likes macros for commands
- fix dist tag for CentOS 6 and Scientific Linux

* Mon Jan 24 2011 Paul Howarth <paul@city-fan.org> - 1.616-2
- BR: perl(Coro), perl(Coro::Handle), perl(Coro::Select) if available (5.8.8+)
- don't filter Coro dependencies
- don't ship DBD::Gofer::Transport::corostream if Coro not available

* Tue Jan  4 2011 Paul Howarth <paul@city-fan.org> - 1.616-1
- update to 1.616
  - fixed spurious dbi_profile lines written to the log when profiling is
    enabled and a trace flag, like SQL, is used
  - fixed to recognize SQL::Statement errors even if instantiated with
    RaiseError=0
  - fixed CPAN RT#61513 by catching attribute assignment to tied table access
    interface
  - fixed some misbehaviour of DBD::File when running within the Gofer server
  - fixed compiler warnings (CPAN RT#62640)
  - optimized connect() to remove redundant FETCH of \%%attrib values
  - improved initialization phases in DBI::DBD::SqlEngine
  - added DBD::Gofer::Transport::corostream, an experimental proof-of-concept
    transport that enables asynchronous database calls with few code changes
  - added additional notes on DBDs that avoid creating a statement in the do()
    method and the effects on error handlers
  - added new attribute "sql_dialect" to DBI::DBD::SqlEngine to allow users
    control over the used SQL dialect (ANSI, CSV or AnyData), defaults to CSV
  - added documentation for DBI::DBD::SqlEngine attributes
  - documented dbd_st_execute return
  - fixed typo in InactiveDestroy
- update patches for shellbangs and old Test::More versions
- filter out dependencies on unavailable perl-Coro modules for now

* Fri Oct  1 2010 Paul Howarth <paul@city-fan.org> - 1.615-2
- rebuild for gcc bug (#634757)

* Thu Sep 23 2010 Paul Howarth <paul@city-fan.org> - 1.615-1
- update to 1.615
  - fixed t/51dbm_file for file/directory names with whitespace (CPAN RT#61445)
  - fixed compiler warnings from ignored hv_store result
  - fixed portability to VMS
- update patch for old Test::More versions
- use local version of File::Path 1.08 if system version is older than that,
  so as to reduce noise in test output

* Fri Sep 17 2010 Paul Howarth <paul@city-fan.org> - 1.614-1
- update to 1.614 (see Changes for details)
- Roadmap and TASKS documentation dropped by upstream
- update UTF-8 and old Test::More patches

* Tue Aug 10 2010 Paul Howarth <paul@city-fan.org> - 1.613-2
- add BR: perl(MLDBM) and perl(SQL::Statement) for improved test coverage
- update patch for old Test::More versions

* Mon Jul 26 2010 Paul Howarth <paul@city-fan.org> - 1.613-1
- update to 1.613
  - fixed Win32 prerequisite module from PathTools to File::Spec
  - changed attribute headings and fixed references in DBI pod
  - corrected typos in DBI::FAQ and DBI::ProxyServer

* Mon Jul 19 2010 Paul Howarth <paul@city-fan.org> - 1.612-1
- update to 1.612 (see Changes for details)
- update patch for old Test::More versions and apply it if we have Test::More
  older than 0.88 as the test suite now uses done_testing()

* Fri Jun 25 2010 Paul Howarth <paul@city-fan.org> - 1.611-3
- rebuild for perl 5.12.1 in Rawhide

* Tue Jun  1 2010 Paul Howarth <paul@city-fan.org> - 1.611-2
- fix dist tag for RHEL-6 Beta

* Fri Apr 30 2010 Paul Howarth <paul@city-fan.org> - 1.611-1
- update to 1.611
  - minimum perl version is now 5.8.1
  - fixed selectcol_arrayref MaxRows attribute to count rows, not values
  - fixed DBI->trace(0, *STDERR)
  - fixes in DBD::DBM for use under threads
  - "rollback() due to DESTROY" warning not issued if ReadOnly set for that dbh
  - added f_lock and f_encoding support to DBD::File
  - added ChildCallbacks => { ... } to specify Callbacks for child handles
  - added DBI::sql_type_cast($value,$type,$flags) to cast string to an SQL type
  - many documentation updates
  - updated dbipport.h to Devel::PPPort 3.19
- add patch to fix test suite for Test::More < 0.84

* Mon Apr 12 2010 Paul Howarth <paul@city-fan.org> - 1.609-5
- import from Fedora
- fix versioned provides for all submodules - properly

* Mon Dec  7 2009 Stepan Kasal <skasal@redhat.com> - 1.609-4
- rebuild against perl 5.10.1

* Thu Sep 24 2009 Stepan Kasal <skasal@redhat.com> - 1.609-3
- provide versioned perl(DBI)

* Sat Jul 25 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.609-2
- rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Wed Jun 10 2009 Stepan Kasal <skasal@redhat.com> - 1.609-1
- new upstream version
- drop unneeded build patch
- move the iconv to convert the source

* Thu Feb 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.607-2
- rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Mon Jul 28 2008 Marcela Maslanova <mmaslano@redhat.com> - 1.607-1
- update

* Wed Feb 27 2008 Tom "spot" Callaway <tcallawa@redhat.com> - 1.601-4
- rebuild for perl 5.10 (again)

* Tue Feb 19 2008 Fedora Release Engineering <rel-eng@fedoraproject.org> - 1.601-3
- Autorebuild for GCC 4.3

* Tue Jan 15 2008 Tom "spot" Callaway <tcallawa@redhat.com> - 1.601-2
- rebuild for new perl

* Fri Oct 26 2007 Robin Norwood <rnorwood@redhat.com> - 1.601-1
- update to latest CPAN version: 1.601
- fix some issues from package review:
  - patch to change #! line in script
  - make script executable
  - fix requires and buildrequires

* Mon Aug 27 2007 Robin Norwood <rnorwood@redhat.com> - 1.58-2
- rebuild

* Mon Aug 13 2007 Robin Norwood <rnorwood@redhat.com> - 1.58-1
- update to latest CPAN version: 1.58

* Thu Jun 07 2007 Robin Norwood <rnorwood@redhat.com> - 1.56-1
- update to latest CPAN version: 1.56
- move the filter requires step into %%prep
- remove very old patch (for perl 5.8.1)
- fix a couple of rpmlint issues (non-UTF8 manpage and script with
  incorrect shebang line

* Sat Dec 02 2006 Robin Norwood <rnorwood@redhat.com> - 1.53-1
- upgrade to latest CPAN version: 1.53

* Thu Aug 24 2006 Robin Norwood <rnorwood@redhat.com> - 1.52-1
- upgrade to 1.52 for bug #202310
	
* Mon Jul 17 2006 Jason Vas Dias <jvdias@redhat.com> - 1.51-1
- upgrade to 1.51

* Wed Jul 12 2006 Jesse Keating <jkeating@redhat.com> - 1.50-3
- rebuild

* Fri Feb 10 2006 Jesse Keating <jkeating@redhat.com> - 1.50-2.2
- bump again for double-long bug on ppc(64)

* Tue Feb 07 2006 Jesse Keating <jkeating@redhat.com> - 1.50-2.1
- rebuilt for new gcc4.1 snapshot and glibc changes

* Fri Feb 03 2006 Jason Vas Dias <jvdias@redhat.com> - 1.50-2
- rebuild for new perl-5.8.8 / gcc / glibc

* Mon Dec 19 2005 Jason Vas Dias<jvdias@redhat.com> - 1.50-1
- upgrade to 1.50

* Fri Dec 16 2005 Jesse Keating <jkeating@redhat.com>
- rebuilt for new gcc

* Fri Dec 16 2005 Jesse Keating <jkeating@redhat.com>
- rebuilt for new gcj

* Wed Apr 13 2005 Jose Pedro Oliveira <jpo@di.uminho.pt> - 1.48-4
- (#154762)
- license information: GPL or Artistic
- removed the Time::HiRes building requirement (see Changes)
- removed the empty .bs file
- corrected file permissions

* Mon Apr 04 2005 Warren Togami <wtogami@redhat.com> - 1.48-3
- filter perl(Apache) (#153673)

* Fri Apr 01 2005 Robert Scheck <redhat@linuxnetz.de> - 1.48-2
- spec file cleanup (#153164)

* Thu Mar 31 2005 Warren Togami <wtogami@redhat.com> - 1.48-1
- 1.48

* Tue Jun 15 2004 Elliot Lee <sopwith@redhat.com>
- rebuilt

* Tue Mar 02 2004 Elliot Lee <sopwith@redhat.com>
- rebuilt

* Fri Feb 13 2004 Chip Turner <cturner@redhat.com> - 1.40-1
- update to 1.40

* Fri Dec 19 2003 Chip Turner <cturner@redhat.com> - 1.39-1
- update to 1.39

* Mon Jul  7 2003 Chip Turner <cturner@redhat.com> - 1.37-1
- upgrade to 1.37

* Wed Apr  2 2003 Chip Turner <cturner@redhat.com> - 1.32-6
- add buildrequires on perl-Time-HiRes

* Tue Feb 18 2003 Chip Turner <cturner@redhat.com>
- update dependency filter to remove dependency on perl(Apache) that
  crept in (#82927)

* Mon Jan 27 2003 Chip Turner <cturner@redhat.com>
- version bump and rebuild

* Sat Dec 14 2002 Chip Turner <cturner@redhat.com>
- don't use rpm internal dep generator

* Wed Nov 20 2002 Chip Turner <cturner@redhat.com>
- rebuild

* Wed Aug  7 2002 Trond Eivind Glomsrød <teg@redhat.com> - 1.30-1
- 1.30

* Tue Jun 25 2002 Trond Eivind Glomsrød <teg@redhat.com> - 1.28-1
- 1.28
- building it also fixes #66304

* Fri Jun 21 2002 Tim Powers <timp@redhat.com>
- automated rebuild

* Wed Jun  5 2002 Trond Eivind Glomsrød <teg@redhat.com> - 1.23-2
- tweak dependency finder - filter out a dependency found within the 
  doc section of a module

* Tue Jun  4 2002 Trond Eivind Glomsrød <teg@redhat.com> - 1.23-1
- 1.23
- some changes to integrate with new Perl
- update URL

* Thu May 23 2002 Tim Powers <timp@redhat.com>
- automated rebuild

* Tue May  7 2002 Trond Eivind Glomsrød <teg@redhat.com> - 1.21-2
- rebuild

* Fri Feb 22 2002 Trond Eivind Glomsrød <teg@redhat.com> - 1.21-1
- 1.21

* Fri Feb  8 2002 Chip Turner <cturner@redhat.com>
- filter out "soft" dependencies: perl(RPC::PlClient) and perl(Win32::ODBC)

* Thu Feb  7 2002 Trond Eivind Glomsrød <teg@redhat.com> - 1.201-2
- rebuild

* Tue Jan 22 2002 Trond Eivind Glomsrød <teg@redhat.com> - 1.201-1
- 1.201

* Wed Jan 09 2002 Tim Powers <timp@redhat.com>
- automated rebuild

* Tue Jan  8 2002 Trond Eivind Glomsrød <teg@redhat.com> - 1.20-1
- 1.20
- proper URL

* Sat Jun 23 2001 Trond Eivind Glomsrød <teg@redhat.com>
- 1.18

* Wed May 30 2001 Trond Eivind Glomsrød <teg@redhat.com>
- 1.16
- change group to Applications/Databases from Applications/CPAN

* Tue May  1 2001 Trond Eivind Glomsrød <teg@redhat.com>
- 1.15

* Tue Feb 27 2001 Trond Eivind Glomsrød <teg@redhat.com>
- cleanups

* Thu Nov 30 2000 Trond Eivind Glomsrød <teg@redhat.com>
- build for main distribution
- use %%{_tmppath}
- change name of specfile
- don't use a find script to generate file lists
- general cleanup
- add descriptive summary and description

* Mon Aug 14 2000 Tim Powers <timp@redhat.com>
- spec file was autogenerated.
